"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = klass;
var _privates = [];

function klass(target) {
  var proto = target.prototype;
  var methodNames = Object.getOwnPropertyNames(proto);
  for (var k in proto) {
    methodNames.push(k);
  }var privatesForTarget = _privates.filter(function (e) {
    return e.target === target;
  }).map(function (e) {
    return e.name;
  }).reduce(function (all, k) {
    all[k] = k;return all;
  }, {});

  function Klass() {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var instance = new (Function.prototype.bind.apply(target, [null].concat(args)))();
    var newProto = {};
    var methodMap = {};

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      var _loop = function _loop() {
        var methodName = _step.value;

        var isPrivate = methodName in privatesForTarget;
        if (isPrivate) return "continue";

        var fn = proto[methodName];

        newProto[methodName] = {
          get: function get() {
            return methodMap[methodName] || (methodMap[methodName] = fn.bind(instance));
          },
          set: function set(newFn) {
            methodMap[methodName] = newFn.bind(instance);instance[methodName] = newFn;
          }
        };
      };

      for (var _iterator = methodNames[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var _ret = _loop();

        if (_ret === "continue") continue;
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    Object.defineProperties(this, newProto);
  }

  return Klass;
}

klass.private = function (target, name, descriptor) {
  _privates.push({ target: target.constructor, name: name });
};